"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schematics_1 = require("@angular-devkit/schematics");
const tasks_1 = require("@angular-devkit/schematics/tasks");
const package_1 = require("./../utils/package");
const config_1 = require("./../utils/config");
const test_1 = require("@schematics/angular/utility/test");
// import {addModuleImportToRootModule} from './../utils/ast';
/*
const ngBootstrapVersion = '2.0.0-alpha.0';
function addNgBootstrapToPackageJson(): Rule {
  return (host: Tree) => {
    addPackageToPackageJson(host, 'dependencies', '@ng-bootstrap/ng-bootstrap', `^${ngBootstrapVersion}`);
    return host;
  };
}*
function addNgBootstrapModuleToAppModule(): Rule {
  return (host: Tree) => {
    addModuleImportToRootModule(host, 'NgbModule.forRoot()', '@ng-bootstrap/ng-bootstrap');
    return host;
  };
}*/
const typesJquery = '3.3.29';
function addBootstrapToPackageJson(options) {
    return (host) => {
        package_1.addPackageToPackageJson(host, 'dependencies', 'bootstrap', `^${options.version}`);
        package_1.addPackageToPackageJson(host, 'devDependencies', '@types/jquery', `^${typesJquery}`);
        return host;
    };
}
function addBootstrapCSS() {
    return (host) => {
        config_1.addStyle(host, './node_modules/bootstrap/dist/css/bootstrap.css');
        return host;
    };
}
function installNodeDeps() {
    return (host, context) => {
        context.addTask(new tasks_1.NodePackageInstallTask());
        return host;
    };
}
function addJqueryPluginToWebpackConfig() {
    return (tree) => {
        const filePath = '/webpack.server.config.js';
        const buffer = tree.read(filePath);
        if (buffer === null) {
            console.log('webpack.server.config.js not exist.');
        }
        // Add to configuration and api routes on server.js
        const toAdd = `
  new webpack.ProvidePlugin({
    "window.$": "jquery",
    "window.jQuery": "jquery"
  }),
`;
        const appComponent = test_1.getFileContent(tree, filePath);
        tree.overwrite(filePath, appComponent.replace(`plugins: [`, `plugins: [` + toAdd));
    };
}
function schematicsBootstrap(options) {
    return (host, context) => {
        if (!config_1.hasBootstrap(host)) {
            return schematics_1.chain([
                schematics_1.branchAndMerge(schematics_1.chain([
                    addBootstrapToPackageJson(options),
                    addJqueryPluginToWebpackConfig(),
                    addBootstrapCSS(),
                    installNodeDeps(),
                ])),
            ])(host, context);
        }
        else {
            schematics_1.noop();
        }
    };
}
exports.schematicsBootstrap = schematicsBootstrap;
//# sourceMappingURL=index.js.map